﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Windows.Forms;

namespace SC2XMLParser
{
    class XMLParse
    {
        private string fileName;
        XmlDocument xDoc = new XmlDocument();

        public List<XmlNode> Parse(string file)
        {
            //MessageBox.Show(file);
            fileName = file;
            List<XmlNode> nodeList = new List<XmlNode>();

            //XmlDocument xDoc = new XmlDocument();
            xDoc.Load(file);

            

            foreach (XmlNode i in xDoc.DocumentElement.ChildNodes)
            {
                bool foundDupe = false;

                if (i.Name == "#comment" || i.Name == "#ProcessingInstruction")
                    continue;

                if (nodeList.Count == 0)
                {
                    nodeList.Add(i);
                    //MessageBox.Show("added: " + i.Name + " Total: " + nodeList.Count.ToString());
                }
                else
                {
                    //check for duplicates
                    foreach (XmlNode j in nodeList)
                    {
                        if (i.Name == j.Name)
                        {
                            //MessageBox.Show("Dupe: " + i.Name + " <=> " + j.Name);
                            foundDupe = true;
                        }
                    }

                    if (!foundDupe)
                    {
                        nodeList.Add(i);
                        //MessageBox.Show("added: " + i.Name + " Total: " + nodeList.Count.ToString());
                    }
                }

                
            }



            return nodeList;
        }

        public List<XmlNode> ChildParse(string parent)
        {
            //MessageBox.Show("Child call");
            
            List<XmlNode> nodeList = new List<XmlNode>();


            xDoc.Load(fileName);

            XmlNodeList parentNodes = xDoc.GetElementsByTagName(parent);

            for (int h = 0; h < parentNodes.Count; h++)
            {
                

                foreach (XmlNode i in parentNodes[h].ChildNodes)
                {
                    bool foundDupe = false;
                    
                    //if (i.HasChildNodes)
                    {
                        if (i.Name == "#comment" || i.Name == "#ProcessingInstruction")
                            continue;

                        if (nodeList.Count == 0)
                        {
                            nodeList.Add(i);
                            //TODO:Check for children
                            //MessageBox.Show("added: " + i.Name + " Total: " + nodeList.Count.ToString());
                        }
                        else
                        {
                            //check for dupes
                            foreach (XmlNode j in nodeList)
                            {
                                if (j.Name == i.Name)
                                {
                                    foundDupe = true;
                                    //MessageBox.Show("Dupe: " + i.Name + " <=> " + j.Name);
                                }
                            }

                            if (!foundDupe)
                            {
                                nodeList.Add(i);
                                //TODO:Check for children
                                //MessageBox.Show("added: " + i.Name + " Total: " + nodeList.Count.ToString());
                            }
                        }
                    }
                }
            }
            return nodeList;
        }
    }
}
